import javax.microedition.lcdui.*;

public class optionsForm extends Form implements CommandListener {  
 midlet midlet;
 Displayable parent;
 TextField attemptsField;
 ChoiceGroup correctionField;
 boolean c;

 optionsForm (midlet midlet, Displayable parent) {
  super (Locale.mainMenu[2]);
  this.midlet = midlet;
  this.parent = parent;
  attemptsField = new TextField (Locale.attemptsHeader, ""+options.attempts, 1, TextField.NUMERIC);
  append (attemptsField);
  correctionField =  new ChoiceGroup ("",Choice.MULTIPLE);
  correctionField.append (Locale.correctionHeader,null);
  c = (options.correction == 1 ? true : false);
  correctionField.setSelectedIndex (0,c);
  append (correctionField);
  addCommand(midlet.OkCommand);
  addCommand(midlet.BackCommand);
 }

 public void show () {
  Display.getDisplay(midlet).setCurrent(this);
  setCommandListener (this);
 }

 public void commandAction(Command c, Displayable d)  {
  if (c == midlet.OkCommand) {
   String s=attemptsField.getString().trim();
   if (s=="") {
    new Message (midlet, this, Locale.WarningHeader).show (Locale.VoidFieldMessage);
    return;
   }
   int n;
   try {
    n=Integer.parseInt (s);
   }
   catch (NumberFormatException e) {
    new Message (midlet, this, Locale.WarningHeader).show (Locale.NumberFormatMessage);
    return;
   }
   if (n<1) {
    new Message (midlet, this, Locale.WarningHeader).show (Locale.NumberRangeMessage);
    return;
   }
   options.attempts=n;
   options.correction=(correctionField.isSelected(0)==true?1:0);
   options.changed=true;
  }
  Display.getDisplay(midlet).setCurrent(parent);
 }

}        