import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.io.*;
import java.util.*;

public class midlet extends MIDlet implements CommandListener { 
 public List main;
 public Vector servers,corrections;
 public options options;
 public Command BackCommand,OkCommand;

 public midlet () {
  main = new List (Locale.mainHeader, List.IMPLICIT, Locale.mainMenu, null);
  servers = new Vector ();
  corrections = new Vector ();
  options = new options (this);
  if (options.numrecords()-2 < 1) {
   servers.addElement (Locale.defaultServer);
   corrections.addElement ("0");
   options.changed=true;
  }
  else options.read ();
  BackCommand = new Command(Locale.BackCommand, Command.BACK, 0);
  OkCommand = new Command(Locale.OkCommand, Command.OK, 0);
 }

 protected void destroyApp(boolean unconditional) { 
  options.write ();
  options.close ();
 }

 protected  void pauseApp() { }

 protected void startApp() {
  Display.getDisplay(this).setCurrent(main);
  main.setCommandListener(this);
 }

 public void quit() { 
  destroyApp(true);
  notifyDestroyed();
 }

 public void commandAction(Command c, Displayable d) {
  if (c==List.SELECT_COMMAND) {
   int selector = main.getSelectedIndex();
   switch (selector) {
    case 0:
     new ConnectionList (this, main, Locale.mainMenu[0], servers, corrections);
    break;
    case 1:
     new itemsList (this, main, Locale.mainMenu[1]).show();
    break;
    case 2:
     new optionsForm (this, main).show();
    break;
    case 3:
     new Message (this, main, Locale.mainMenu[3]).show (Locale.HelpTxt);
    break;
    case 4:
     new Message (this, main, Locale.mainMenu[4]).show (Locale.AboutTxt);
    break;
    case 5:
     quit();
    break;
   }
  }
 }

}
